Index: modules/dnet-openaire_dli-workflows/trunk/src/test/java/eu/dnetlib/functionality/modular/ui/stastdli/StatsStoreTest.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/test/java/eu/dnetlib/functionality/modular/ui/stastdli/StatsStoreTest.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/test/java/eu/dnetlib/functionality/modular/ui/stastdli/StatsStoreTest.java	(revision 40969)
@@ -1,10 +1,9 @@
 package eu.dnetlib.functionality.modular.ui.stastdli;
 
-import java.util.Date;
-import java.util.List;
-import java.util.Map;
-
+import eu.dnetlib.dli.openaire.transform.ConfigurationTestConfig;
+import eu.dnetlib.msro.workflows.dli.manager.StatsInfo;
 import org.junit.Assert;
+import org.junit.Ignore;
 import org.junit.Test;
 import org.junit.runner.RunWith;
 import org.springframework.beans.factory.annotation.Autowired;
@@ -11,34 +10,34 @@
 import org.springframework.test.context.ContextConfiguration;
 import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
 
-import eu.dnetlib.dli.openaire.transform.ConfigurationTestConfig;
-import eu.dnetlib.msro.workflows.dli.manager.StatsInfo;
+import java.util.Date;
+import java.util.List;
+import java.util.Map;
 
 @RunWith(SpringJUnit4ClassRunner.class)
 @ContextConfiguration(classes = ConfigurationTestConfig.class)
 public class StatsStoreTest {
 
-	@Autowired
-	private StatsStore store;
+    @Autowired
+    private StatsStore store;
 
-	@Test
-	public void test() {
+    @Ignore
+    @Test
+    public void test() {
+        Map<Date, List<StatsInfo>> map = store.getAllStats();
+        for (Date key : map.keySet()) {
 
-		Map<Date, List<StatsInfo>> map = store.getAllStats();
+            List<StatsInfo> lastStats = map.get(key);
+            Assert.assertTrue(lastStats.size() > 0);
+            for (StatsInfo info : lastStats) {
+                Assert.assertNotNull(info.getDatasource());
+                System.out.println(String.format("Date: %s %s  D:%d P:%d, O:%d, R:%d", key, info.getDatasource(), info.getNumberOfDatasets(),
+                        info.getNumberOfPublication(),
+                        info.getNumberOfObjects(), info.getNumberOfRelations()));
 
-		for (Date key : map.keySet()) {
+            }
+        }
 
-			List<StatsInfo> lastStats = map.get(key);
-			Assert.assertTrue(lastStats.size() > 0);
-			for (StatsInfo info : lastStats) {
-				Assert.assertNotNull(info.getDatasource());
-				System.out.println(String.format("Date: %s %s  D:%d P:%d, O:%d, R:%d", key, info.getDatasource(), info.getNumberOfDatasets(),
-						info.getNumberOfPublication(),
-						info.getNumberOfObjects(), info.getNumberOfRelations()));
+    }
 
-			}
-		}
-
-	}
-
 }
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/AggregateObjectJobNode.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/AggregateObjectJobNode.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/dli/workflows/nodes/feeding/AggregateObjectJobNode.java	(revision 40969)
@@ -9,9 +9,12 @@
 import eu.dnetlib.msro.dli.workflows.nodes.feeding.utility.DLIRecordParser;
 import eu.dnetlib.msro.dli.workflows.nodes.transform.DLIUtils;
 import eu.dnetlib.msro.workflows.dli.manager.DLIDBManager;
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherResolver;
+import eu.dnetlib.msro.workflows.dli.publisher.PublisherResolverFactory;
 import eu.dnetlib.msro.workflows.nodes.ProgressJobNode;
 import eu.dnetlib.msro.workflows.nodes.SimpleJobNode;
 import eu.dnetlib.msro.workflows.util.ProgressProvider;
+import eu.dnetlib.msro.workflows.util.WorkflowsConstants;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.springframework.beans.factory.annotation.Autowired;
@@ -56,6 +59,10 @@
      */
     private BlockingQueue<String> inputBlockingQueue;
 
+
+    @Autowired
+    PublisherResolverFactory publisherResolverFactory;
+
     /**
      * The result set client factory.
      */
@@ -74,6 +81,8 @@
     @Autowired
     private DLIDBManager manager;
 
+
+
     /**
      * The added elemtents.
      */
@@ -92,14 +101,19 @@
         inputBlockingQueue = new ArrayBlockingQueue<String>(1000);
         final List<Future<Boolean>> responses = Lists.newArrayList();
         final ExecutorService executor = Executors.newFixedThreadPool(numberOfThread);
-        String nameSpacePrefix = token.getEnv().getAttribute("namespacePrefix");
-        responses.add(executor.submit(new DatabaseFeederWorker(inputBlockingQueue, new DLIRecordParser(), manager, nameSpacePrefix, END_QUEUE)));
-        int addedElemtents = 0;
+        final String datasourceId = token.getFullEnv().getAttribute(WorkflowsConstants.DATAPROVIDER_ID);
+        PublisherResolver resolver = publisherResolverFactory.getInstance(datasourceId);
+        String nameSpacePrefix = token.getEnv().getAttribute("parentDatasourceId");
+        responses.add(executor.submit(new DatabaseFeederWorker(inputBlockingQueue, new DLIRecordParser(), manager, nameSpacePrefix, END_QUEUE, resolver)));
+
+
+
+        int addedElements = 0;
         for (String s : input) {
             try {
                 inputBlockingQueue.put(s);
                 this.addedElemtents++;
-                log.debug("Added " + addedElemtents);
+                log.debug("Added " + addedElements);
             } catch (InterruptedException e) {
                 log.error("Error on put item on blocking Queue.\n item:" + s, e);
             }
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/RCSBParser.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/RCSBParser.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/RCSBParser.java	(revision 40969)
@@ -31,7 +31,7 @@
 	private static final Log log = LogFactory.getLog(RCSBParser.class); // NOPMD by marko on 11/24/08 5:02 PM
 
 	/** The Constant CROSSREF_NS_PREFIX. */
-	public static final String RCBS_NS_PREFIX = "rcsb";
+	public static final String RCBS_NS_PREFIX = "dli::r3d100010327";
 
 	/**
 	 * Parses the record.
@@ -91,7 +91,7 @@
 				}
 			}
 			if (object.getPid() != null && object.getPidType() != null) {
-				DLIProvenance provenance = new DLIProvenance(RCBS_NS_PREFIX, "resolved", "complete", null, null, true);
+				DLIProvenance provenance = new DLIProvenance(RCBS_NS_PREFIX, "resolved", "complete", null, null, true, "RCSB", "",RCBS_NS_PREFIX);
 				object.setDatasourceProvenance(Lists.newArrayList(provenance));
 				object.fixContribution(provenance);
 				object.setType(DLIObjectType.dataset);
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParserJSON.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParserJSON.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/resolver/CrossRefParserJSON.java	(revision 40969)
@@ -27,7 +27,7 @@
     /**
      * The Constant CROSSREF_NS_PREFIX.
      */
-    public static final String CROSSREF_NS_PREFIX = "crs";
+    public static final String CROSSREF_NS_PREFIX = "dli::crossref";
     private static final Log log = LogFactory.getLog(CrossRefParserJSON.class); // NOPMD by marko on 11/24/08 5:02 PM
 
     public DLIObject parseRecord(final String record) {
@@ -35,8 +35,8 @@
         if (record == null) return null;
         JsonElement jElement = new JsonParser().parse(record);
         JsonObject mainObj = jElement.getAsJsonObject();
-        if (!mainObj.get("message").isJsonNull()) {
-            return new DLIObject();
+        if (mainObj.get("message").isJsonNull()) {
+            return null;
         }
         JsonObject message = mainObj.getAsJsonObject("message");
         DLIObject currentObject = new DLIObject();
@@ -54,7 +54,7 @@
             currentObject.setTitles(new String[]{message.get("title").toString()});
         }
 
-        if (!message.get("author").isJsonNull()) {
+        if (message.get("author") != null && !message.get("author").isJsonNull()) {
             JsonArray author = message.getAsJsonArray("author");
             List<String> authorList = Lists.newArrayList();
             for (JsonElement anAuthor : author) {
@@ -62,10 +62,10 @@
 
                 String family = "";
                 String given = "";
-                if (!currentAuth.get("family").isJsonNull()) {
+                if (currentAuth != null && currentAuth.get("family") != null && !currentAuth.get("family").isJsonNull()) {
                     family = currentAuth.get("family").getAsString();
                 }
-                if (!currentAuth.get("given").isJsonNull()) {
+                if (currentAuth != null && currentAuth.get("given") != null && !currentAuth.get("given").isJsonNull()) {
                     given = currentAuth.get("given").getAsString();
                 }
                 authorList.add(String.format("%s %s", family, given));
@@ -73,6 +73,9 @@
             currentObject.setAuthors(authorList.toArray(new String[]{}));
         }
         DLIProvenance provenance = new DLIProvenance(CROSSREF_NS_PREFIX, "resolved", "complete", null, null, true);
+        if(message.get("publisher") != null && !message.get("publisher").isJsonNull()) {
+            provenance.setPublisher(message.get("publisher").getAsString());
+        }
         currentObject.fixContribution(provenance);
         currentObject.setDatasourceProvenance(Lists.newArrayList(provenance));
         currentObject.setCompletionStatus(DLICompletionStatus.complete.toString());
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_pubmed.xslt
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_pubmed.xslt	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_pubmed.xslt	(revision 40969)
@@ -0,0 +1,51 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:datetime="http://exslt.org/dates-and-times"
+				xmlns:exslt="http://exslt.org/common" xmlns:oai="http://www.openarchives.org/OAI/2.0/"
+				xmlns:dri="http://www.driver-repository.eu/namespace/dri"
+				xmlns:dnet="eu.dnetlib.miscutils.functional.xml.DnetXsltFunctions"
+				version="1.0"
+				exclude-result-prefixes="xsl datetime exslt dnet">
+
+	<xsl:param name="repositoryId"/>
+	<xsl:param name="namespacePrefix"></xsl:param>
+	<xsl:param name="dataprovider_id"></xsl:param>
+	<xsl:variable name="status" select="/*[local-name() = 'record']/*[local-name() = 'header']/@status"/>
+	<xsl:variable name="pid" select="//*[local-name()='dliObject']/*[local-name()='localIdentifier']"></xsl:variable>
+	<xsl:variable name="pid_type" select="//*[local-name()='dliObject']/*[local-name()='localIdentifier']/@type"></xsl:variable>
+	<xsl:template match="/">
+		<oai:record xmlns="http://namespace.openaire.eu/"
+		>
+			<oai:header>
+				<dri:objIdentifier>
+					<xsl:value-of select="concat($namespacePrefix,'::', dnet:md5($pid),'::',dnet:md5($pid_type))"/>
+				</dri:objIdentifier>
+				<dri:recordIdentifier>
+					<xsl:value-of select="$pid"/>
+				</dri:recordIdentifier>
+				<dri:dateOfCollection>
+					<xsl:value-of select="datetime:dateTime()"/>
+				</dri:dateOfCollection>
+				<dri:repositoryId>
+					<xsl:value-of select="$dataprovider_id"/>
+				</dri:repositoryId>
+				<dri:datasourceprefix>
+					<xsl:value-of select="$namespacePrefix"/>
+				</dri:datasourceprefix>
+			</oai:header>
+			<xsl:choose>
+				<xsl:when test="count(//*[local-name() = 'dliObject']) &gt; 0">
+					<metadata>
+						<dliObject xmlns="http://www.dli.eu" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
+							<xsl:copy-of select="//*[local-name() = 'dliObject']//*"/>
+							<provenance>
+								<datasource completionStatus="complete" provisionMode="collected">
+									<xsl:value-of select="$namespacePrefix"/>
+								</datasource>
+							</provenance>
+						</dliObject>
+					</metadata>
+				</xsl:when>
+			</xsl:choose>
+		</oai:record>
+	</xsl:template>
+</xsl:stylesheet>
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/doimanager/xmlTemplate.st
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/doimanager/xmlTemplate.st	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/doimanager/xmlTemplate.st	(revision 40969)
@@ -19,7 +19,8 @@
       		<dli:provenance>      		
          		$object.datasourceProvenance:{
          		<dli:datasourceInfo>
-         			<dli:datasource completionStatus="$it.completionStatus$" provisionMode="$it.provisionMode$" visible="$it.visible$">$it.escapedDatasource$</dli:datasource>
+         			<dli:provider completionStatus="$it.completionStatus$" provisionMode="$it.provisionMode$" datasourceId="$it.escapedDatasourceId$" visible="$it.visible$">$it.escapedDatasource$</dli:provider>
+         			<dli:publisher datasourceId="$it.publisherId$" >$it.escapedPublisher$</dli:publisher>
          			<dli:contributedFields>$it.escapedXMLDatasourceContribution$</dli:contributedFields>
          			<dli:collectionDate>$it.collectionDate$</dli:collectionDate>
          		</dli:datasourceInfo>
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBManager.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBManager.java	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/manager/DLIDBManager.java	(revision 40969)
@@ -126,7 +126,7 @@
         Connection connection = null;
         try {
             connection = datasource.getConnection();
-            final String query = "SELECT  name, web, icon_uri, ds_id, latitude, longitude FROM dli_datasource WHERE exportable=TRUE ";
+            final String query = "SELECT  name, web, icon_uri, ds_id, latitude, longitude FROM dli_datasource WHERE exportable=TRUE and typology<>'resolver'";
 
             PreparedStatement ps = connection.prepareStatement(query);
 
@@ -253,13 +253,11 @@
      *
      * @return the data source by name maps
      */
-    public Map<String, Pair<String, Boolean>> getDataSourceByNameMaps() {
-
+    public Map<String, Pair<String, Boolean>> getDataSourceByIDMaps() {
         Connection connection = null;
         try {
             connection = datasource.getConnection();
             connection.setAutoCommit(false);
-
             PreparedStatement ps = connection.prepareStatement("select ds_id, name, exportable from dli_datasource");
             ResultSet result = ps.executeQuery();
             Map<String, Pair<String, Boolean>> datasourceMap = Maps.newHashMap();
@@ -277,7 +275,33 @@
         } finally {
             closeConnection(connection);
         }
+    }
 
+
+
+    public Map<String, String> getPublisherByNameMap() {
+        Connection connection = null;
+        try {
+            connection = datasource.getConnection();
+            connection.setAutoCommit(false);
+            PreparedStatement ps = connection.prepareStatement("select name, ds_id from dli_datasource");
+            ResultSet result = ps.executeQuery();
+            Map<String, String> publisherMap = Maps.newHashMap();
+            while (result.next()) {
+                publisherMap.put(result.getString("name").toLowerCase().trim(), result.getString("ds_id"));
+            }
+            return publisherMap;
+        } catch (Exception e) {
+            try {
+                connection.rollback();
+            } catch (SQLException e1) {
+                log.error("Error on rollback ", e1);
+            }
+            return null;
+        } finally {
+            closeConnection(connection);
+        }
+
     }
 
     /**
@@ -328,7 +352,7 @@
     private void updateCompleteRelation(final Connection connection, final String type, final Array titles, final String pid, final Array authors)
             throws SQLException {
         PreparedStatement update = connection.prepareStatement(
-                "update dli_relation set target_type =?, target_title=?,  target_authors=?, relationship_completion_status=? where id_relation=?");
+                "update dli_relation set target_type =?, target_title=?,  target_authors=?, relationship_completion_status=? where target_pid=?");
         update.setString(1, type);
         update.setFetchSize(100);
         String title = null;
@@ -592,8 +616,8 @@
      * @throws SQLException the SQL exception
      */
     private void insertObjectProvenance(final DLIObject input, final Connection connection, final String table_name) throws SQLException {
-        String sql = "INSERT INTO " + table_name + " (ds_id, dli_id, provision_mode, completion_status, contribution) " +
-                "VALUES (?,?,?,?,?)";
+        String sql = "INSERT INTO " + table_name + " (ds_id, dli_id, provision_mode, completion_status, contribution, publisher) " +
+                "VALUES (?,?,?,?,?, ?)";
         if (input.getDatasourceProvenance() == null || input.getDatasourceProvenance().size() == 0) return;
         PreparedStatement statement = null;
         try {
@@ -605,6 +629,7 @@
                 statement.setString(3, provenance.getProvisionMode());
                 statement.setString(4, provenance.getCompletionStatus());
                 statement.setString(5, provenance.getDatasourceContribution());
+                statement.setString(6, provenance.getPublisher());
                 log.debug("executing statement " + statement.toString());
                 int totalUpdate = statement.executeUpdate();
                 log.debug("Updated " + totalUpdate + " record");
@@ -724,6 +749,8 @@
                 final Function<DLIObject, String> convertFunction = new Function<DLIObject, String>() {
                     @Override
                     public String apply(DLIObject input) {
+                        if (input.getIdentifier()== null || StringUtils.isEmpty(input.getIdentifier()))
+                            log.error("OGGETTO NULLO");
                         return extractXMLfromDLIObject(input);
                     }
                 };
@@ -889,7 +916,7 @@
             connection = datasource.getConnection();
 
             HashMap<String, StatsInfo> stats = Maps.newHashMap();
-            Map<String, Pair<String, Boolean>> datasourceMap = getDataSourceByNameMaps();
+            Map<String, Pair<String, Boolean>> datasourceMap = getDataSourceByIDMaps();
 
             PreparedStatement ps = connection.prepareStatement(getAllObjectByTypeSQL);
             ps.setString(1, DLIObjectType.publication.toString());
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverFactory.java
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverFactory.java	(nonexistent)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/java/eu/dnetlib/msro/workflows/dli/publisher/PublisherResolverFactory.java	(revision 40969)
@@ -0,0 +1,44 @@
+package eu.dnetlib.msro.workflows.dli.publisher;
+
+import com.google.gson.Gson;
+import com.google.gson.GsonBuilder;
+import eu.dnetlib.enabling.is.lookup.rmi.ISLookUpException;
+import eu.dnetlib.enabling.is.lookup.rmi.ISLookUpService;
+import eu.dnetlib.enabling.locators.UniqueServiceLocator;
+import org.springframework.beans.factory.annotation.Autowired;
+
+import java.util.List;
+
+/**
+ * Created by sandro on 15/01/16.
+ */
+public class PublisherResolverFactory {
+
+    private static final String queryTemplate = "//RESOURCE_PROFILE[.//RESOURCE_IDENTIFIER/@value/string()='%s']//FIELD[key = 'provConfigParameters']/value/text()";
+
+
+    @Autowired
+    private UniqueServiceLocator locator;
+
+
+    public PublisherResolver getInstance(final String datasourceId) throws ISLookUpException {
+        ISLookUpService lookupService = locator.getService(ISLookUpService.class);
+        List<String> results =lookupService.quickSearchProfile(String.format(queryTemplate, datasourceId));
+
+        if (results.size()==0) {
+            return null;
+        }
+        final String json = results.get(0);
+
+
+        GsonBuilder gsonBuilder = new GsonBuilder();
+        gsonBuilder.registerTypeAdapter(PublisherConfigurationParameters.class, new PublisherResolverRuleDeserializer());
+        Gson gson = gsonBuilder.create();
+        PublisherConfigurationParameters parameters = gson.fromJson(json, PublisherConfigurationParameters.class);
+
+        PublisherResolver resolver= new PublisherResolver();
+        resolver.setParameters(parameters);
+        return resolver;
+    }
+
+}
Index: modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_elsevier.xslt
===================================================================
--- modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_elsevier.xslt	(revision 40968)
+++ modules/dnet-openaire_dli-workflows/trunk/src/main/resources/eu/dnetlib/msro/dli_openaire/workflows/repo-hi/xslt/ingest_elsevier.xslt	(revision 40969)
@@ -1,60 +1,81 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-    xmlns:datetime="http://exslt.org/dates-and-times" xmlns:exslt="http://exslt.org/common"
-    xmlns:oai="http://www.openarchives.org/OAI/2.0/"    
-    xmlns:dnet="eu.dnetlib.miscutils.functional.xml.DnetXsltFunctions"
-    xmlns:dri="http://www.driver-repository.eu/namespace/dri" 
-    xmlns:dli="http://www.dli.eu"
-    exclude-result-prefixes="xsl datetime dnet exslt">
-    <!--  " -->  
-    <xsl:param name="repositoryId" />
-    <xsl:param name="namespacePrefix"></xsl:param>
-    <xsl:param name="dataprovider_id"></xsl:param>
-    
-    <xsl:variable name="id" select="//*[local-name()='column' and ./@isID='true']"></xsl:variable>   
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+				xmlns:datetime="http://exslt.org/dates-and-times"
+				xmlns:exslt="http://exslt.org/common" xmlns:oai="http://www.openarchives.org/OAI/2.0/"
+				xmlns:dnet="eu.dnetlib.miscutils.functional.xml.DnetXsltFunctions"
+				xmlns:dri="http://www.driver-repository.eu/namespace/dri"
+				xmlns:dli="http://www.dli.eu"
+				version="1.0"
+				exclude-result-prefixes="xsl datetime dnet exslt">
+	<!--  " -->
+	<xsl:param name="repositoryId"/>
+	<xsl:param name="namespacePrefix"></xsl:param>
+	<xsl:param name="dataprovider_id"></xsl:param>
+	<xsl:param name="parentDatasourceId"></xsl:param>
+
+	<xsl:variable name="id" select="//*[local-name()='column' and ./@isID='true']"></xsl:variable>
 	<xsl:variable name="doitype" select="//*[local-name()='column' and ./@name='db']"></xsl:variable>
-	 <xsl:variable name="dnetId" select="concat($doitype,'::',$id)"></xsl:variable>    
-    <xsl:variable name="date" select="//*[local-name()='column' and ./@name='date']"></xsl:variable>        
-    <xsl:variable name="reldoi" select="//*[local-name()='column' and ./@name='ArticleID']"></xsl:variable>
-    <xsl:template match="/">
-        <oai:record xmlns="http://namespace.openaire.eu/"
-            xmlns:dc="http://purl.org/dc/elements/1.1/"
-            xmlns:dr="http://www.driver-repository.eu/namespace/dr"
-            xmlns:prov="http://www.openarchives.org/OAI/2.0/provenance"
-            xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
-            
-            <oai:header> 
-                <xsl:if test=" string-length(normalize-space($id)) &gt; 0">
-                    <dri:objIdentifier><xsl:value-of select="concat($namespacePrefix,'::', dnet:md5($dnetId),'::', dnet:md5($reldoi))"/></dri:objIdentifier>
-                </xsl:if>               
-                
-                <dri:recordIdentifier><xsl:value-of select="$id"/></dri:recordIdentifier>
-                <dri:dateOfCollection><xsl:value-of select="datetime:dateTime()"/></dri:dateOfCollection>
-                <dri:repositoryId><xsl:value-of select="$dataprovider_id"/></dri:repositoryId>
-                <dri:datasourceprefix><xsl:value-of select="$namespacePrefix"/></dri:datasourceprefix>                
-            </oai:header>
-            <metadata>
-                <dli:dliObject>
-                    <dnetResourceIdentifier><xsl:value-of select="concat($namespacePrefix,'::', dnet:md5($dnetId),'::', dnet:md5($reldoi))"/></dnetResourceIdentifier>
-                    <localIdentifier>
-                    	<xsl:attribute name="type"><xsl:value-of select="$doitype"/></xsl:attribute>                        
-                        <xsl:value-of select="$id"/>
-                    </localIdentifier>               
-                    <objectType>dataset</objectType>
-                    <date ><xsl:value-of select="$date"></xsl:value-of></date>
-                    <provenance>
-         				<datasource completionStatus="incomplete" provisionMode="collected"><xsl:value-of select="$namespacePrefix"/></datasource>
-         			</provenance>
-         			<completionStatus>incomplete</completionStatus>
-                    <relations>
-                        <relation>
-                            <pid type="doi"><xsl:value-of select="$reldoi"/></pid>
-                            <typeOfRelation>unknown</typeOfRelation>
-                        </relation>
-                    </relations>
-                </dli:dliObject>                
-            </metadata>           
-        </oai:record>
-    </xsl:template>    
+	<xsl:variable name="dnetId" select="concat($doitype,'::',$id)"></xsl:variable>
+	<xsl:variable name="date" select="//*[local-name()='column' and ./@name='date']"></xsl:variable>
+	<xsl:variable name="reldoi" select="//*[local-name()='column' and ./@name='ArticleID']"></xsl:variable>
+	<xsl:template match="/">
+		<oai:record xmlns:dc="http://purl.org/dc/elements/1.1/"
+					xmlns:dr="http://www.driver-repository.eu/namespace/dr"
+					xmlns:prov="http://www.openarchives.org/OAI/2.0/provenance"
+					xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+					xmlns="http://namespace.openaire.eu/">
+
+			<oai:header>
+				<xsl:if test=" string-length(normalize-space($id)) &gt; 0">
+					<dri:objIdentifier>
+						<xsl:value-of select="concat($parentDatasourceId,'::', dnet:md5($dnetId),'::', dnet:md5($reldoi))"/>
+					</dri:objIdentifier>
+				</xsl:if>
+
+				<dri:recordIdentifier>
+					<xsl:value-of select="$id"/>
+				</dri:recordIdentifier>
+				<dri:dateOfCollection>
+					<xsl:value-of select="datetime:dateTime()"/>
+				</dri:dateOfCollection>
+				<dri:repositoryId>
+					<xsl:value-of select="$dataprovider_id"/>
+				</dri:repositoryId>
+				<dri:datasourceprefix>
+					<xsl:value-of select="$namespacePrefix"/>
+				</dri:datasourceprefix>
+			</oai:header>
+			<metadata>
+				<dli:dliObject>
+					<dnetResourceIdentifier>
+						<xsl:value-of select="concat($parentDatasourceId,'::', dnet:md5($dnetId),'::', dnet:md5($reldoi))"/>
+					</dnetResourceIdentifier>
+					<localIdentifier>
+						<xsl:attribute name="type">
+							<xsl:value-of select="$doitype"/>
+						</xsl:attribute>
+						<xsl:value-of select="$id"/>
+					</localIdentifier>
+					<objectType>dataset</objectType>
+					<date>
+						<xsl:value-of select="$date"></xsl:value-of>
+					</date>
+					<provenance>
+						<datasource completionStatus="incomplete" provisionMode="collected">
+							<xsl:value-of select="$parentDatasourceId"/>
+						</datasource>
+					</provenance>
+					<completionStatus>incomplete</completionStatus>
+					<relations>
+						<relation>
+							<pid type="doi">
+								<xsl:value-of select="$reldoi"/>
+							</pid>
+							<typeOfRelation>unknown</typeOfRelation>
+						</relation>
+					</relations>
+				</dli:dliObject>
+			</metadata>
+		</oai:record>
+	</xsl:template>
 </xsl:stylesheet>
